// https://sourceforge.net/tracker/index.php?func=detail&aid=420518&group_id=7586&atid=107586

#include <boost/python/class_builder.hpp>

class Base {
  public:
    int f(int i) { return -i; }
};

class Derived : public Base {};

BOOST_PYTHON_MODULE_INIT(bind_inherited)
{
  try
  {
    boost::python::module_builder this_module("bind_inherited");

    // does not compile without this (not a compiler bug)
    boost::python::class_builder<Base> base_class(this_module, "Base");

    boost::python::class_builder<Derived> derived_class(this_module, "Derived");

    derived_class.def(boost::python::constructor<>());

    derived_class.def(&Derived::f, "f");
  }
  catch(...) { boost::python::handle_exception(); }
}
